package j2d.edge;

import j2d.ImageUtils;
import ip.transforms.Gauss;
import j2d.ImageProcessorInterface;

import java.awt.*;


public class MagDOGProcessor implements ImageProcessorInterface {

    private int kernelWidth;
    private double sigma;


    public MagDOGProcessor(
            int _kernelWidth,
            double _sigma) {

        kernelWidth = _kernelWidth;
        sigma = _sigma;
    }

    public Image process(Image img) {
        return ImageUtils.sobel(
                magDoG(img));

    }


    private Image magDoG(Image img) {
        return ImageUtils.convolution(img,
                Gauss.getMagnitudeOfTheDerivativeOfGauss(
                        kernelWidth, kernelWidth, sigma));
    }

}

